# phpfmt for Visual Studio Code

[![GitHub](https://img.shields.io/github/release/kokororin/vscode-phpfmt.svg)](https://github.com/kokororin/vscode-phpfmt/releases)
[![Visual Studio Marketplace](https://vsmarketplacebadge.apphb.com/installs-short/kokororin.vscode-phpfmt.svg)](https://marketplace.visualstudio.com/items?itemName=kokororin.vscode-phpfmt)
[![Build Status](https://travis-ci.org/kokororin/vscode-phpfmt.svg?branch=master)](https://travis-ci.org/kokororin/vscode-phpfmt)

The missing phpfmt extension for Visual Studio Code.

## Read this first

If you believe you found a bug with [phpF](https://github.com/subins2000/phpF), please **don't open an issue in this repository**.  
This project is just an extension for [phpF](https://github.com/subins2000/phpF).

## Installation

Open command palette <kbd>F1</kbd> and select `Extensions: Install Extension`, then search for phpfmt.

**Note**: PHP >= 5.6 is required.  
(https://github.com/subins2000/phpF#requirements)  

**Note**: For Windows users, see [#1](https://github.com/kokororin/vscode-phpfmt/issues/1)

## Usage

<kbd>F1</kbd> -> `phpfmt: format this file`

or keyboard shortcut `ctrl+shift+i` which is Visual Studio Code default formatter shortcut

or right mouse context menu `Format Document` or `Format Selection`

## Configuration

| Key | Type | Description | Default |
| -------- | ----------- | ----------- | ----------- |
| phpfmt.php_bin | `string` | php executable path | "php" | 
| phpfmt.debug_mode | `boolean` | allow debug mode | false | 
| phpfmt.format_on_save | `boolean` | Execute phpfmt on save | false | 
| phpfmt.detect_indent | `boolean` | auto detecting indent type and size (will ignore indent_with_space) | false | 
| phpfmt.psr1 | `boolean` | activate PSR1 style | false | 
| phpfmt.psr1_naming | `boolean` | activate PSR1 style - Section 3 and 4.3 - Class and method names case. | false | 
| phpfmt.psr2 | `boolean` | activate PSR2 style | true | 
| phpfmt.indent_with_space | `integer \| boolean` | use spaces instead of tabs for indentation. Default 4 | 4 | 
| phpfmt.enable_auto_align | `boolean` | disable auto align of ST_EQUAL and T_DOUBLE_ARROW | false | 
| phpfmt.visibility_order | `boolean` | fixes visibiliy order for method in classes - PSR-2 4.2 | false | 
| phpfmt.passes | `array` | call specific compiler pass | [] | 
| phpfmt.exclude | `array` | disable specific passes | [] | 
| phpfmt.smart_linebreak_after_curly | `boolean` | convert multistatement blocks into multiline blocks | false | 
| phpfmt.yoda | `boolean` | yoda-style comparisons | false | 
| phpfmt.cakephp | `boolean` | Apply CakePHP coding style | false | 
| phpfmt.custom_arguments | `string` | provide custom arguments to overwrite default arguments generated by config | "" | 


## Contribute

### Running extension
- Open this repository inside VSCode
- Debug sidebar
- `Launch Extension`

### Running tests
```bash
$ npm test
```
